local key = ModPath .. '	' .. RequiredScript
if _G[key] then return else _G[key] = true end

-- SIGNAL INDICATOR
function HUDTeammate:animate_invulnerability(duration)
	if self._radial_health_panel:child("ABI_Indicator_radial_custom") then
		self._radial_health_panel:remove(self._radial_health_panel:child("ABI_Indicator_radial_custom"))
	end

	local ABI_Indicator_radial_custom = self._radial_health_panel:bitmap({
		texture = ABI_Signals.settings.indicator_texture_path .. tostring(ABI_Signals.settings.indicator_color),
		name = "ABI_Indicator_radial_custom",
		blend_mode = "add",
		visible = false,
		render_template = "VertexColorTexturedRadial",
		layer = 5,
		color = Color(1, 0, 0, 0),
		w = self._radial_health_panel:w(),
		h = self._radial_health_panel:h()
	})

	ABI_Indicator_radial_custom = self._radial_health_panel:child("ABI_Indicator_radial_custom")
	if not ABI_Indicator_radial_custom then
		return
	end

	ABI_Indicator_radial_custom:animate(function(o)
		o:set_color(Color(1, 1, 1, 1))
		o:set_visible(true)
		over(duration, function(p)
			o:set_color(Color(1, 1 - p, 1, 1))
		end)
		o:set_visible(false)
	end)
end

-- ADAPTATION FOR WOLFHUD'S CUSTOM HUD (the one from VanillaHUD+)
-- but it'll not support ABI's custom textures
if VHUDPlus then
	if VHUDPlus:getSetting({ "CustomHUD", "HUDTYPE" }, 2) == 3 then
		if HUDTeammateCustom then
			function HUDTeammateCustom:animate_invulnerability(duration)
				local ABI_Indicator_radial_custom = self._player_status._ability_radial_icon
				if (not ABI_Indicator_radial_custom) then
					return
				end

				ABI_Indicator_radial_custom:animate(function(o)
					o:set_color(Color(1, 1, 1, 1))
					o:set_visible(true)
					over(duration, function(p)
						o:set_color(Color(1, 1 - p, 1, 1))
					end)
					o:set_visible(false)
				end)
			end
		end
	end
end
