local key = ModPath .. '	' .. RequiredScript
if _G[key] then return else _G[key] = true end

-- HOOK EVENT
Hooks:PreHook(PlayerManager, "activate_temporary_upgrade", "ABI_Signal_activate_temporary_upgrade",
function(self, category, upgrade)
	-- note: as for update 236.1, upgrade_value is a table with
	-- 2 values {duration, cooldown} for ARMORER, ANARCHIST and COPYCAT_ANARCHIST (classic)
	-- 3 values {threshold, duration, cooldown} for COPYCAT grace period (copycat)
	local upgrade_type = { ["none"] = nil, ["classic"] = "armor_break_invulnerable",
		["copycat"] = "mrwi_health_invulnerable" }
	-- verifying if upgrade matches
	if upgrade == upgrade_type["classic"] or upgrade == upgrade_type["copycat"] then
		local upgrade_value = self:upgrade_value(category, upgrade)
		if upgrade_value == 0 then
			return
		end
		-- effect
		if ABI_Signals.settings.effect_enabled then
			if upgrade == upgrade_type["classic"] then
				ABI_Signals.control.effect_duration_timer = upgrade_value[1]
			elseif upgrade == upgrade_type["copycat"] then
				ABI_Signals.control.effect_duration_timer = upgrade_value[2]
			end
			local hud = managers.hud:script(PlayerBase.PLAYER_INFO_HUD_FULLSCREEN_PD2)
			
			if hud.panel:child("ABI_Effect_hud_panel") then
				hud.panel:remove(hud.panel:child("ABI_Effect_hud_panel"))
			end
			local ABI_Effect_hud_panel = hud.panel:bitmap({
				name = "ABI_Effect_hud_panel",
				visible = false,
				texture = ABI_Signals.settings.effect_texture_path,
				layer = 0,
				color = Color(ABI_Signals.settings.effect_color),
				blend_mode = "add",
				w = hud.panel:w(),
				h = hud.panel:h(),
				x = 0,
				y = 0
			})
		end
		-- indicator
		if ABI_Signals.settings.indicator_enabled then
			local teammate_panel = managers.hud:get_teammate_panel_by_peer()
			if teammate_panel then
				if not teammate_panel.animate_invulnerability then
					do end
				elseif upgrade == upgrade_type["classic"] then
					teammate_panel:animate_invulnerability(upgrade_value[1])
				elseif upgrade == upgrade_type["copycat"] then
					teammate_panel:animate_invulnerability(upgrade_value[2])
				end
			end
		end
	end
end)
